import java.sql.*;
import java.util.ArrayList;

public class Person implements ActiveRecord {
	private long personId;
	private String name;
	private char sex;
	
	public Person(long personId, String name, char sex) {
		this.personId = personId;
		this.name = name;
		this.sex = sex;		
	}
	
	public long getPersonID() {
		return personId;
	}
	
	public String getName() {
		return name;
	}
	
	public char getSex() {
		return sex;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public void setSex(char sex) {
		this.sex = sex;
	}

	@Override
	public void insert() throws SQLException {
		String sql = "INSERT INTO `Person` VALUES (?, ?, ?);";
		try (PreparedStatement ps = ConnectionManager.getConnection().prepareStatement(sql)) {
			ps.setLong(1,  this.personId);
			ps.setString(2,  this.name);
			ps.setString(3, "" + this.sex);
			ps.executeUpdate();
		}
	}

	@Override
	public void update() throws SQLException {
		String sql = "UPDATE `Person` SET `Name`=?, `Sex`=? WHERE `PersonID`=?";
		try (PreparedStatement ps = ConnectionManager.getConnection().prepareStatement(sql)) {
			ps.setString(1,  this.name);
			ps.setString(2, "" + this.sex);
			ps.setLong(3,  this.personId);
			ps.executeUpdate();
		}
	}

	@Override
	public void delete() throws SQLException {
		String sql = "DELETE FROM `Person` WHERE `PersonID`=?";
		try (PreparedStatement ps = ConnectionManager.getConnection().prepareStatement(sql)) {
			ps.setLong(1,  this.personId);
			ps.executeUpdate();
		}
	}
	
	public String toString() {
		return "Person: " + this.personId + " : " + this.name + " : " + this.sex;
	}
	
	public static ArrayList<Person> findAll() throws SQLException {
		String sql = "SELECT * FROM Person";
		ArrayList<Person> personen = new ArrayList<Person>();
		try (PreparedStatement ps = ConnectionManager.getConnection().prepareStatement(sql)) {
			try (ResultSet rs = ps.executeQuery()) {
				int i = 0;
				while (rs.next()) {
					personen.add(new Person(rs.getLong("PersonID"), rs.getString("Name"), rs.getString("Sex").charAt(0)));
				}
			}
		}
		return personen;
	}
}
